#!/usr/bin/env python
# -*- coding: utf-8 -*-
#       @FILE: main
#       
#       Copyright 2009 foxoman <romance990033@hotmail.com>
#			Blog : foxoman.wordpress.com
#			Development WEB : foxoman.googlecode.com
#       
#       This program is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#       
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#       
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.
#
#		

## TODO : ADD more filter .!
## TODO : Drop and drag
## TODO : Puase skip job
## TODO : splash
## TODO : play input or output with mplayer
## FIXME : when selecting sub check if realy load the subtitle file .!
## FIXME : System try
## FIXME : subtitle font and path not working with space .!
## FIXME : need to move h264 log to home




import gtk
import os
import gtk.glade
import subprocess
from subprocess import *
import gobject
import re
from options import Options
from singleton import *
import sys
import commands
import gettext
import pango

PREFIX = os.path.normpath(os.path.join(os.path.dirname(__file__), ".."))

# i18n
gettext.install("divxc", os.path.join(PREFIX, 'divx-converter/locale'))

## Testing arabic language
#ar = gettext.translation("divxc", os.path.join(PREFIX, 'divx-converter/locale'),languages=['ar'])
#ar.install()

APP = _("DivX Converter")
VER = "2.0"
DISTRO = commands.getoutput("lsb_release -is")

print "\n Starting " + APP + " version " + VER + " in " + DISTRO +"\n\n"


# notifications using pynotify in non-ubuntu dist see $notify
def notification(message):
	pass

try:
	import pynotify

	if pynotify.init("Basics"):
		def notification(message):
			n = pynotify.Notification(APP, message)
			n.show()
except ImportError:
	pass





class Window(InheritableSingleton):
	

	def __init__(self):	
		super(type(self), self).__init__()
		

		"""
		+++++++++++++++++++++++++++++++++++++++++++++
		Load the glade file and setup the main window
		+++++++++++++++++++++++++++++++++++++++++++++
		"""
		PREFIX = os.path.normpath(os.path.join(os.path.dirname(__file__), ".."))
		
		gtk.window_set_default_icon_from_file(os.path.join(PREFIX, 'icons/divxc.png'))

		self.glade = glade = gtk.glade.XML(os.path.join(PREFIX, 'divx-converter/main.glade'))
		self.glade.signal_autoconnect(self)
		
		self.glade.get_widget("window").set_title(APP)
		

		self.animate = self.glade.get_widget('animate')

		pixbufanim = gtk.gdk.PixbufAnimation(os.path.join(PREFIX, 'divx-converter/Throbber.gif'))
		self.animate.set_from_animation(pixbufanim)
		
		
		self.progress_window = self.glade.get_widget('Progress')
		self.progressbar_all = self.glade.get_widget('Progressbar All')
		self.progressbar_current = self.glade.get_widget('Progressbar Current')
		self.progressbar_current.set_pulse_step(0.01)
		self.label_current = self.glade.get_widget('Label Current')
		self.video_label = self.glade.get_widget('Video Label')
		self.combobox = self.glade.get_widget('ComboBox')

		self.two_pass_checkbox = self.glade.get_widget('2-Pass-Encoding')
		


		self.treeview = self.glade.get_widget('Files')
		
		# Names of columns in the file list
		VISIBLE_COLUMNS = [_("Filename")]
		ALL_COLUMNS = VISIBLE_COLUMNS + ["META"]
		args = []
		for name in ALL_COLUMNS:
			if name in VISIBLE_COLUMNS:
				args.append(gobject.TYPE_STRING)
			else:
				args.append(gobject.TYPE_PYOBJECT)
		self.model = apply(gtk.ListStore, args)
		#self.model = gtk.ListStore(str, str)

		self.treeview.set_model(self.model)
		

		renderer = gtk.CellRendererText()
		for name in VISIBLE_COLUMNS:
			column = gtk.TreeViewColumn(name,
										renderer,
										markup=ALL_COLUMNS.index(name))
			self.treeview.append_column(column)
		#self.treeview.append_column(gtk.TreeViewColumn(_("Filename"), gtk.CellRendererText(), text=0))
		#self.treeview.get_selection().set_mode(gtk.SELECTION_MULTIPLE)
				# make treeview searchable
		self.treeview.set_search_column(0)
		
		
		self.main_window = self._window = self.glade.get_widget('window')
		
		self.framerate = self.glade.get_widget('framerate')
		self.resize = self.glade.get_widget('resize')
		self.framerate_fps = self.glade.get_widget('framerate_fps')
		self.resize_width = self.glade.get_widget('resize_width')
		self.resize_height = self.glade.get_widget('resize_height')
		
		self.crop_label = self.glade.get_widget('crop_label')
		
		self.top_crop = self.glade.get_widget('top_crop')
		
		self.bottom_crop = self.glade.get_widget('bottom_crop')
		
		
		self.resize_video = False
		self.force_framerate = False
	
		self.expression = re.compile('.*\( *(\d*)%\).*')
		self.expression_time = re.compile('.*\Trem: *(\d*)min\.*')
		self.expression_size = re.compile('.*\min *(\d*)mb\.*')
		
		self.check_for_dependency()
	
		#self.pause = self.glade.get_widget('Pause')
		#assert self.pause
		self.cancel = self.glade.get_widget('Cancel')
		self.details = self.glade.get_widget('DetailsButton')

		#self.details.set_image(gtk.image_new_from_stock(gtk.STOCK_INFO, gtk.ICON_SIZE_BUTTON))
		self.close = self.glade.get_widget('Close')
		self.buttonbox = self.glade.get_widget('ButtonBox')
		self.buttonbox.remove(self.cancel)
		#self.buttonbox.remove(self.pause)
		self.statbar = self.glade.get_widget('statbar')
		
		self._options = Options()
		self.glade.get_widget('combobox1').set_sensitive(False);
		self.glade.get_widget('FontFile').set_sensitive(False);		
		self.glade.get_widget('fontbutton1').set_sensitive(False);
		self.glade.get_widget('font_size').set_sensitive(False);
		self.glade.get_widget('alphaback').set_sensitive(False);
		
		self.glade.get_widget("combobox1").set_active(5)
		self.glade.get_widget("combobox2").set_active(0)
		self.glade.get_widget("combobox6").set_active(1)
		self.glade.get_widget("combobox7").set_active(2)
		self.glade.get_widget("combobox4").set_active(0)	
		self.glade.get_widget("combobox3").set_active(0)	
		self.glade.get_widget("combobox5").set_active(2)	
		self.glade.get_widget("combobox8").set_active(10)	
		self.glade.get_widget("srate").set_active(3)	

		
		self.set_up_filechooser(self.glade.get_widget("filechooserbutton1"))
		self.set_up_filechooser_sub()
		
		self.glade.get_widget("cbr_vb").set_active(8)
		self.glade.get_widget("vbr_vb").set_active(0)

		
		

		title = self.glade.get_widget("output_label")
		label = title.get_child()
		label.set_markup('%s' % _("<b>Output</b> Settings :"))
		label.set_alignment(0.0, 0.5)
		title.select()
		
		input_label = self.glade.get_widget("input_label")
		label_in =input_label.get_child()
		label_in.set_markup('%s' % _("<b>Input</b> File(s) :"))
		label_in.set_alignment(0.0, 0.5)
		input_label.select()


		# Interface Language Setup i18n
		self.glade.get_widget("label22").set_label(_("Main Window"))
		self.glade.get_widget("label19").set_label(_("Video Filters"))
		self.glade.get_widget("label3").set_label(_("<b>Video Filters</b>"))
		self.glade.get_widget("label20").set_label(_("Audio Filters"))
		self.glade.get_widget("label5").set_label(_("<b>Audio Filters</b>"))
		self.glade.get_widget("label21").set_label(_("Subtitle"))
		self.glade.get_widget("label1").set_label(_("<b>Subtitle</b>"))
		self.glade.get_widget("label4").set_label(_("<b>Output Preset</b>"))
		self.glade.get_widget("label2").set_label(_("<b>Output Directory</b>"))
		self.glade.get_widget("checkbutton2").set_label(_("Enable"))
		self.glade.get_widget("alphaback").set_label(_("Alpha Black Background"))
		
		
		self.glade.get_widget("toolbutton1").set_label(_("Add File(s)"))
		self.glade.get_widget("toolbutton7").set_label(_("Remove File(s)"))
		self.glade.get_widget("toolbutton4").set_label(_("Convert"))
		self.glade.get_widget("toolbutton8").set_label(_('Help'))
		self.glade.get_widget("toolbutton6").set_label(_("Quit"))
		

		self.glade.get_widget("menuitem1").get_child().set_text(_('File'))
		self.glade.get_widget("menuitem4").get_child().set_text(_('Help'))

		
		
		self.glade.get_widget("Progress").set_title(_("DivX converter Progress"))
		self.glade.get_widget("Details").set_title(_("Details"))
		
		self.glade.get_widget("hbox23").hide()
		self.glade.get_widget("hbox24").hide()
		self.glade.get_widget("vbox2").hide()
		
		# Disable until i complete it :)
		#self.menu()
		
		# run the main window
		self.main_window.show()
		
		self.notify(_("Starting DivX Converter %s .!") % VER , 1000)

		
	"""
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	@ menu : System try menu 
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	"""		
	def menu(self):
		self.statusIcon = gtk.StatusIcon()
		self.statusIcon.set_from_file("/usr/share/icons/divxc.png")
		self.statusIcon.set_tooltip(APP)
		self.statusIcon.set_visible(True)

		self.statusIcon.connect('popup-menu', self.popup_menu_cb)
		self.statusIcon.connect('activate', self.show_menu_cb)
		self.menu = gtk.Menu()

		helpMenuItem = gtk.ImageMenuItem(gtk.STOCK_HELP)
		helpMenuItem.connect('activate', self.on_help)
		self.menu.append(helpMenuItem)

		self.menu.append(gtk.SeparatorMenuItem())

		menuItem = gtk.ImageMenuItem(gtk.STOCK_QUIT)
		menuItem.connect('activate', self.on_destroy)
		self.menu.append(menuItem)
		self.menu.show_all()
		

	
	def show_menu_cb(self, widget):
		self.menu.popup(None, None, self.menu_pos, 0, gtk.get_current_event_time())

	def popup_menu_cb(self, widget, button, activate_time):
		self.menu.popup(None, None, self.menu_pos, button, activate_time)

	def menu_pos(self, menu):
		return gtk.status_icon_position_menu(self.menu, self.statusIcon)
		
		
	"""
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	@ execute : execute system command 
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	"""		
		
	def execute(self, command):
		return os.system(command)
		
	
		
	"""
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	@ notify : send system notification msg use notigy-osd in ubuntu and pynotify in other linux ditro
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	"""		

	def notify(self, message, timeout=3000):

		if DISTRO.lower() == "ubuntu" or DISTRO.lower() == "mint" or DISTRO.lower() == "sabily":
			os.system("notify-send \"" + APP + "\" \"" + message + "\" -i /usr/share/icons/divxc.png -t " + str(timeout))
		else:
			notification(message)



	"""
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	@ on_checkbutton2_toggled : to enable or diable font proprites
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	"""
	def on_checkbutton2_toggled(self, data=None):
		if self.glade.get_widget('checkbutton2').get_active() :
			self.glade.get_widget('combobox1').set_sensitive(True);
			self.glade.get_widget('FontFile').set_sensitive(True);
			self.glade.get_widget('fontbutton1').set_sensitive(True);
			self.glade.get_widget('font_size').set_sensitive(True);
			self.glade.get_widget('alphaback').set_sensitive(True);

		else :
			self.glade.get_widget('combobox1').set_sensitive(False);
			self.glade.get_widget('FontFile').set_sensitive(False);		
			self.glade.get_widget('fontbutton1').set_sensitive(False);
			self.glade.get_widget('font_size').set_sensitive(False);		
			self.glade.get_widget('alphaback').set_sensitive(False);		
	
	

	"""
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	@ on_togg_mp3_enc_mode : switch between mp3 encoding mode  
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	"""		
	def on_togg_mp3_enc_mode(self, data=None):
		if self.glade.get_widget("abr").get_active():
			self.glade.get_widget("cbr_vb").hide()
			self.glade.get_widget("vbr_vb").hide()
			self.glade.get_widget("Audio Label").show()
			self.glade.get_widget("Audio SpinButton").show()
			self.glade.get_widget("Unit Audio").show()

		if self.glade.get_widget("cbr").get_active():
			self.glade.get_widget("cbr_vb").show()
			self.glade.get_widget("vbr_vb").hide()
			self.glade.get_widget("Audio Label").hide()
			self.glade.get_widget("Audio SpinButton").hide()
			self.glade.get_widget("Unit Audio").hide()

		if self.glade.get_widget("vbr").get_active():
			self.glade.get_widget("cbr_vb").hide()
			self.glade.get_widget("vbr_vb").show()
			self.glade.get_widget("Audio Label").hide()
			self.glade.get_widget("Audio SpinButton").hide()
			self.glade.get_widget("Unit Audio").hide()

			
	
	"""
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	@ get_preset_options : set the command for the selected preset
	@ Preset from divxenc
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	"""	
	def get_preset_options(self):
		model = self.glade.get_widget("combobox2").get_model()
		active = self.glade.get_widget("combobox2").get_active()
		preset = model[active][0];

		if preset == "Normal Quality" :
			options = ":vmax_b_frames=0:vme=4:mbd=1:v4mv:lumi_mask=0.05:dark_mask=0.01:precmp=0:cmp=0:subcmp=0:dia=1:last_pred=0:preme=0:qns=0:vlelim=-4:vcelim=9:autoaspect"
		if preset == "High Quality" :
			options = ":vmax_b_frames=2:vme=4:mbd=2:v4mv:bidir_refine=0:lumi_mask=0:dark_mask=0:precmp=0:cmp=0:subcmp=0:dia=2:trell:last_pred=0:preme=0:qns=0:vlelim=-4:vcelim=9:autoaspect"
		if preset == "Very High Quality" :
			options = ":vmax_b_frames=2:vme=4:mbd=2:v4mv:bidir_refine=1:lumi_mask=0:dark_mask=0:precmp=0:cmp=2:subcmp=2:dia=2:trell:cbp:mv0:last_pred=2:preme=1:qns=0:vlelim=-4:vcelim=9:autoaspect"
		if preset == "Extreme High Quality" :
			options = ":vmax_b_frames=2:vme=4:mbd=2:v4mv:bidir_refine=2:lumi_mask=0:dark_mask=0:precmp=0:cmp=2:subcmp=2:dia=-1:trell:cbp:mv0:last_pred=4:preme=1:qns=0:vlelim=-4:vcelim=9:autoaspect"
		if preset == "Ultra High Quality" :
			options = ":vmax_b_frames=2:vme=4:mbd=2:v4mv:bidir_refine=3:lumi_mask=0:dark_mask=0:precmp=2:cmp=2:subcmp=2:dia=-1:trell:cbp:mv0:last_pred=6:preme=2:qns=1:vlelim=-4:vcelim=9:autoaspect"
		if preset == "Insane High Quality" :
			options = ":vmax_b_frames=2:vme=4:mbd=2:v4mv:bidir_refine=4:lumi_mask=0:dark_mask=0:precmp=6:cmp=6:subcmp=6:dia=-1:trell:cbp:mv0:last_pred=8:preme=2:qns=2:vlelim=-4:vcelim=9:autoaspect"
		if preset == "Stand-alone HW compatible" :
			options = ":vmax_b_frames=2:vme=4:mbd=2:bidir_refine=1:lumi_mask=0:dark_mask=0:precmp=0:cmp=2:subcmp=2:dia=-1:trell:cbp:mv0:last_pred=2:preme=1:qns=0:autoaspect -noodml"
		if preset == "Sony PlayStation 3" :
			options =":vmax_b_frames=0:vme=4:mbd=2:lumi_mask=0:dark_mask=0:precmp=0:cmp=2:subcmp=2:dia=-1:trell:cbp:mv0:preme=1:qns=0:autoaspect -noodml"
		if preset == "Apple iPod" :
			options = ":vmax_b_frames=0:vme=4:mbd=2:lumi_mask=0:dark_mask=0:precmp=0:cmp=2:subcmp=2:dia=-1:trell:cbp:mv0:preme=1:qns=0:autoaspect -noodml"

		
		return options
		
		
	
	"""
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	@ get_sub_options : setup subtitle command
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	"""	
	def get_sub_options(self):
		
		options = ""
		
		if self.glade.get_widget("alphaback").get_active():
			# this will make an alpha black background
			options += " -sub-bg-alpha 80 -sub-bg-color 0"
		options += (" -sub %s" % self.glade.get_widget("FontFile").get_filename())
		options += (" -subfont-text-scale ")
		options += str(int(self.glade.get_widget("font_size").get_value()))
		options += (" -subcp ")
		model = self.glade.get_widget("combobox1").get_model()
		active = self.glade.get_widget("combobox1").get_active()
		codec = model[active][0];
		options += (codec)
		options += (" -subfont %s" % self.glade.get_widget("fontbutton1").get_font_name())

		return options
	
	
	"""
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	@ is_sub : see if we enable the subtitling
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	"""
	def is_sub(self):
		if self.glade.get_widget('checkbutton2').get_active() :
			return True
		else :
			return False
	
	
	
	"""
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	@ set_up_filechooser : setup video file chooser window
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	"""
	def set_up_filechooser(self,file_chooser):   
		video = gtk.FileFilter()
		video.set_name("Video Files")
		video.add_mime_type("video/*")
		# Special case for Flash video
		video.add_mime_type("application/x-flash-video")
		# this one for realmedia
		video.add_mime_type("application/vnd.rn-realmedia")
		allmedia = gtk.FileFilter()
		allmedia.set_name("All Media Files")
		allmedia.add_mime_type("video/*")
		allmedia.add_mime_type("application/x-flash-video")
		allmedia.add_mime_type("application/vnd.rn-realmedia")
		allfiles = gtk.FileFilter()
		allfiles.set_name("All Files")
		allfiles.add_pattern("*")
		file_chooser.add_filter(allmedia) 
		file_chooser.add_filter(video)
		file_chooser.add_filter(allfiles)
		
		if os.path.exists(os.path.expanduser("~/Videos")):
			file_chooser.set_current_folder(os.path.expanduser("~/Videos"))
		else:
			file_chooser.set_current_folder(os.path.expanduser("~"))
		
		file_chooser.set_local_only(False)
		
		
		
	"""
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	@ set_up_filechooser_sub : setup subtitle file chooser window
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	"""	
	def set_up_filechooser_sub(self):   
		sub = gtk.FileFilter()
		sub.set_name("MicroDVD subtitles")
		sub.add_mime_type("text/*")
		sub.add_mime_type("text/x-microdvd")
		idx = gtk.FileFilter()
		idx.set_name("VobSub Subtitle Index")
		idx.add_mime_type("text/*")
		idx.add_mime_type("application/octet-stream")
		srt = gtk.FileFilter()
		srt.set_name("SubRip subtitles")
		srt.add_mime_type("text/*")
		srt.add_mime_type("application/x-subrip")
		ass = gtk.FileFilter()
		ass.set_name("Advanced SubStation Alpha Subtitle")
		ass.add_mime_type("text/*")
		ass.add_mime_type("text/plain")
		allfiles = gtk.FileFilter()
		allfiles.set_name("All Files")
		allfiles.add_pattern("*")
		file_chooser = self.glade.get_widget("FontFile")
		file_chooser.add_filter(sub) 
		file_chooser.add_filter(ass) 
		file_chooser.add_filter(idx) 
		file_chooser.add_filter(srt)
		file_chooser.add_filter(allfiles)
		file_chooser.set_current_folder(os.path.expanduser("~"))
		
		file_chooser.set_local_only(False)
		
		
	"""
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	@ set_up_filechooser_sub_folder : make the last video folder
	is the default folder for the subtitle
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	"""	
	def set_up_filechooser_sub_folder(self,folder):   
		file_chooser = self.glade.get_widget("FontFile")
		if (folder != None) and (os.access(folder,os.W_OK)):
			outfile_folder = folder
		else:
			outfile_folder = os.path.expanduser('~')

		file_chooser.set_current_folder(outfile_folder)
		
		file_chooser.set_local_only(False)
	
	"""
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	@ default methods
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	"""	
	def get_glade(self):
		return self.glade
	
	def get_window(self):
		return self._window
	
	
	"""
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	@ check_for_dependency : check if mencoder support DivX and mp3
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	"""	
	def check_for_dependency(self):

		# the best thing to do is to check if installed mencoder support divx
		divx = commands.getoutput("mencoder -ovc help 2>/dev/null | awk '{print $1}' | grep 'lavc'")
		
		if divx != "lavc" :
					dialog = gtk.MessageDialog(self.main_window, gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT, type=gtk.MESSAGE_ERROR, buttons=gtk.BUTTONS_OK, message_format=(_("Installed Mencoder does not support DivX \n\n Enable DivX Support 'lavc' or this application will not work .!")))
					dialog.run()
					dialog.hide()
					self.notify(_("Installed Mencoder does not support DivX \n\n Enable DivX Support 'lavc' or this application will not work .!"), 500)
	
		# and to check if installed mencoder support mp3 lame
		dlame = commands.getoutput("mencoder -oac help 2>/dev/null | awk '{print $1}' | grep 'mp3lame'")
	
		if dlame != "mp3lame" :
					dialog = gtk.MessageDialog(self.main_window, gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT, type=gtk.MESSAGE_ERROR, buttons=gtk.BUTTONS_OK, message_format=(_("Installed Mencoder does not support mp3 \n\n Enable mp3 Support 'lame' or this application will not work .!")))
					dialog.run()
					dialog.hide()
					self.notify(_("Installed Mencoder does not support mp3 \n\n Enable mp3 Support 'lame' or this application will not work .!"), 500)


	"""
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	@ on_output : get encoding information from cmd output
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	"""	
	def on_output(self, source, condition):
		line = source.readline()
		if len(line) > 0:
			match = self.expression.match(line)
			if match:
				self.file_fraction = float(match.group(1))/100
				if self.two_pass:
					self.file_fraction /= 2
					if self.first_pass_done:
						self.file_fraction += 0.5 # +50% (the first pass)
				self.progressbar_all.set_fraction(float(self.current_file) / len(self.filenames) + self.file_fraction / len(self.filenames))
				
				percent = []
				filed = int(self.file_fraction * 100)
				percent.append (filed)
				time_rem = self.expression_time.match(line)
				time_remain = str(time_rem.group(1))
				size_es = self.expression_size.match(line)
				size_estimat = str(size_es.group(1))
				
				percent.append (time_remain)
				percent.append (size_estimat)
				
				t2ndpass = _("2nd pass")
				t1stpass = _("1st pass")
				encoding = _("Encoding")
				
				if self.two_pass:
					if self.first_pass_done:
						passing = t2ndpass
					else:
						passing = t1stpass
				else:
						passing = encoding
				
				msg = (_("[%(passing)s] %(percent)i%% (%(time)s min Remaining time) (%(size)s mb Estimating Size)")) % {
				"passing": passing,
				"percent": percent[0],
				"time": percent[1],
				"size": percent[2],
				}
				
				file_cur = (_("File %d of %d") % (self.current_file + 1, len(self.filenames)))
				if filed != 0 and filed != 50:
					self.progressbar_current.set_text(msg)
					
					self.progressbar_current.set_fraction(self.file_fraction)
					self.progress_window.set_title("[%s %s] %s %s"% (filed,'%',file_cur,passing))
				else:
					self.progressbar_current.pulse()
					self.progress_window.set_title("%s"% passing)
					if self.two_pass:
						if self.first_pass_done:
							self.progressbar_current.set_text(t2ndpass)
						else:
							self.progressbar_current.set_text(t1stpass)
					else:
						self.progressbar_current.set_text(encoding)
			self.output += line
			self.animate.show()
			return True
		self.animate.hide()
		return False # This means that we have read all lines in source
		
		

	"""
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	@ on_end : check if we finish or if we have 2 pass encoding
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	"""		
	def on_end(self, pid, error_code):
		

		if error_code == 0:
			if self.first_pass_done or not self.two_pass:
				self.current_file += 1 # Only continue with the next file if the second pass finished

			else:
				self.first_pass_done = True # Now spawn_cmd will start the second pass
			self.spawn_cmd()
		else:
			self.on_details()
			self.progress_window.hide()
			self.main_window.show()
	
	
	
	"""
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	@ spawn_cmd : Encoding command managed start here
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	"""		
	def spawn_cmd(self):
		global outfile;
		
		if self.current_file >= len(self.filenames): # Are we finished?
			self.on_finished()
			self.progress_window.set_title(_("Finish conversion"))
			self.notify(_("Finish conversion"), 1000)
			return
	
		# Check destination is writable
		if not os.access(self.glade.get_widget("filechooserbutton1").get_filename(), os.W_OK):
			dialogue = gtk.MessageDialog(self._window, gtk.DIALOG_MODAL,
								gtk.MESSAGE_ERROR,
								gtk.BUTTONS_CLOSE,
								(_("Folder is not writable")))
			dialogue.format_secondary_text(_("Cannot save to this folder"))
			dialogue.run()
			dialogue.destroy() 
			self.on_finished()
			self.notify(_("Folder is not writable \n\n\n Cannot save to this folder"), 1000)         
			return
		
		# set up output file name and extension	
		new_ext = 'avi'
		basename, ext = os.path.splitext(os.path.basename(self.filenames[self.current_file]))
		outfile_name = '%s.%s' % (basename, new_ext)
		#outfile = os.path.join(self.glade.get_widget("filechooserbutton1").get_filename(), outfile_name)

		if self.two_pass:
			
			if self.first_pass_done:
				outfile = os.path.join(self.glade.get_widget("filechooserbutton1").get_filename(), outfile_name)
			else:
				outfile = "/dev/null" #os.path.join("/tmp/", "divxc-1stpass.avi") #"/dev/null" #os.path.join("/tmp/", outfile_name)
		else:
			outfile = os.path.join(self.glade.get_widget("filechooserbutton1").get_filename(), outfile_name)


			# Now check whether the file already exists
		if os.path.exists(outfile) and (self.filenames[self.current_file] != None):        
			if os.path.samefile(outfile, self.filenames[self.current_file]):
				dialogue = gtk.MessageDialog(self._window, gtk.DIALOG_MODAL,
									gtk.MESSAGE_ERROR,
									gtk.BUTTONS_CLOSE,
									(_("Using the same file for input and output")))
				dialogue.format_secondary_text(_("Save to a different location."))
				dialogue.run()
				dialogue.destroy()
				self.on_finished()
				self.notify(_("Using the same file for input and output \n\n\n Save to a different location."), 1000)          
				return    
		
		
		# make a screenshot from the input file
		self.execute("ffmpegthumbnailer -i %s -o /tmp/divxc-screenshot.png -f -t 20 -w" % ('"' + self.filenames[self.current_file] + '"'))
		
		# display it in progress window
		self.screenshot = self.glade.get_widget('screenshot')

		PREFIX2 = os.path.normpath("/")
		self.screenshot.set_from_file(os.path.join(PREFIX2, 'tmp/divxc-screenshot.png'))
		self.screenshot.show()
		
		
		
		# display input file name in progress window and in the notification
		self.label_current.set_label(os.path.basename(self.filenames[self.current_file]))
		
		# TODO : Notify about 2npass
		self.notify((_("Convert file :\n\n\n %s") %os.path.basename(self.filenames[self.current_file])), 500)
		self.progressbar_all.set_text((_("File %d of %d") % (self.current_file + 1, len(self.filenames))))
		
		if self.two_pass:
			
			if self.first_pass_done:
				in_file = self.filenames[self.current_file] #os.path.join("/tmp/", "divxc-1stpass.avi")
			else:
				in_file = self.filenames[self.current_file]  #"/dev/null" #os.path.join("/tmp/", outfile_name)
		else:
			in_file = self.filenames[self.current_file]
		
		# start mencoder cmd with nice for lower cpu usage
		self.cmdline = ["nice","-n","10","mencoder", in_file]

		# get video and audio option and append it to mencoder cmd
		options = ""
		options += Options().get_video_options(self.two_pass, self.first_pass_done, self.combobox)
		
		
		# get sub options
		if self.is_sub() :
			options += self.get_sub_options()
			
			
		options += Options().get_audio_options()
		
		if self.glade.get_widget("divx").get_active() or self.glade.get_widget("divx4").get_active() or self.glade.get_widget("xvid").get_active():
			# move log file to user home
			options += " -passlogfile " + os.path.expanduser('~/.DivXConverter.log')
		
		#FIXME: need to move x264 to user home ' when i try to move it the 2nd pass won't work	
		if self.glade.get_widget("x264").get_active():
			options += " -passlogfile x264_2pass.log"
		
		self.cmdline += options.split(" ")
		self.cmdline.append("-o")

		self.cmdline.append(outfile)
		

		print "Encoding cmdline:"
		for arg in self.cmdline:
			print arg,
		print '\n'
		self.pipe = subprocess.Popen(self.cmdline, stdout=PIPE, stderr=PIPE, universal_newlines=True)
		gobject.io_add_watch(self.pipe.stdout,
		                     gobject.IO_IN | gobject.IO_HUP,
		                     self.on_output)
		gobject.io_add_watch(self.pipe.stderr,
		                     gobject.IO_IN | gobject.IO_HUP,
		                     self.on_output)
		# Wait for the process to complete
		gobject.child_watch_add(self.pipe.pid, self.on_end)
		


		
	"""
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	@ cancel_cmd : cancel encoding cmd
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	"""		
		
	def cancel_cmd(self):
		self.current_file = len(self.filenames)
		os.kill(self.pipe.pid, 9)
		self.notify(_("Conversion Canceled !."), 1000)
		
		
	"""
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	@ on_convert : start encoding
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	"""			
	def on_convert(self, widget):
		self.finished = False
		self.buttonbox.add(self.cancel)
		#self.buttonbox.add(self.pause)
		self.buttonbox.remove(self.close)
		self.buttonbox.remove(self.details)
		self.output = ""
		self.filenames = []
		iter = self.model.get_iter_first()
		while iter:
			self.filenames.append(self.model.get_value(iter, 1))
			iter = self.model.iter_next(iter)
		self.current_file = 0
		self.first_pass_done = False
		if self.two_pass_checkbox.get_active() and self.two_pass_checkbox.flags() & gtk.SENSITIVE:
			self.two_pass = True
		else:
			self.two_pass = False

		self.spawn_cmd()
		self.progress_window.show_all()

		self.main_window.hide()


	"""
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	@ on_delete_progress_window : close progress window
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	"""		
	def on_delete_progress_window(self, widget, event):
		self.on_cancel(widget)
		return True


	"""
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	@ on_cancel : close progress window
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	"""		
	def on_cancel(self, widget):
		
		if self.finished:
			self.progress_window.hide()
			self.main_window.show()
		else:
			response = self.execute('zenity --question --text="%s"' % _("Are you sure you wish to proceed?"))
			if response == 0 :
				self.cancel_cmd()
				self.progress_window.hide()
				self.main_window.show()
			'''
			dialog = gtk.MessageDialog(self.progress_window, type=gtk.MESSAGE_QUESTION, buttons=gtk.BUTTONS_YES_NO,	message_format='Do you really want to abort the encoding process?')
			dialog.set_title("Cancel encoding?")
			response = dialog.run()
			dialog.destroy()
			if response == gtk.RESPONSE_YES:
				self.cancel_cmd()
				self.progress_window.hide()
				self.main_window.show()
			'''



	
	def on_delete(self, widget, event):
		return False



	"""
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	@ on_destroy : close main window and quit the application
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	"""	
	def on_destroy(self, widget):
		#self.statusIcon.set_visible(False)
		self.notify(_("Thank you for using DivX converter .! %s") % ("\n\n\n.::. Foxoman .::."), 1000)
		gtk.main_quit()
		sys.exit(0)


	"""
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	@ on_aboyt : run about dialog
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	"""		
	def on_about(self, widget):
		AboutDialog()


	"""
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	@ add_file : add file to the treelist
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	"""		
	def add_file(self, file):
		self.model.append([os.path.basename(file), file])
		


	"""
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	@ on_add : run file chooser
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	"""		
	def on_add(self, widget):
		filechooser = gtk.FileChooserDialog(title=_("Choose Files"), action=gtk.FILE_CHOOSER_ACTION_OPEN,\
		                                    buttons=(gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN,gtk.RESPONSE_OK))
		filechooser.set_transient_for(self.main_window)
		filechooser.set_select_multiple(True)
		self.set_up_filechooser(filechooser);
		response = filechooser.run()
		if response == gtk.RESPONSE_OK:
			files = filechooser.get_filenames()
			folder = filechooser.get_current_folder()
			self.set_up_filechooser_sub_folder(folder)

		else:
			files = None
		filechooser.destroy()
		
		if files:
			for file in files:
				self.add_file(file)



	"""
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	@ on_remove : remove file from the list
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	"""	
	def on_remove(self, widget):
		selected_rows = self.treeview.get_selection().get_selected_rows()
		references = [] # We must convert this into a list of TreeRowReferences because we change the model afterwards
		for selected_row in selected_rows[1]:
			references.append(gtk.TreeRowReference(self.model, selected_row))
		for reference in references: # Now we can change the model
			self.model.remove(self.model.get_iter(reference.get_path()))
	

	

	"""
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	@ on_details : run details dialog
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	"""
	def on_details(self, widget=None):
		self.glade.get_widget('Commandline').get_buffer().set_text(self.output)
		self.glade.get_widget('Details').show_all()



	"""
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	@ on_details : close details dialog
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	"""	
	def on_close_details(self, widget, data=None):
		self.glade.get_widget('Details').hide()
		return True




	"""
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	@ on_details : finish the encoding and run main window
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	"""
	def on_finished(self):
		self.finished = True
		self.buttonbox.remove(self.cancel)
		#self.buttonbox.remove(self.pause)
		self.buttonbox.add(self.details)
		self.buttonbox.add(self.close)
		self.progressbar_all.set_fraction(1)
		self.progressbar_current.set_fraction(1)
		self.progressbar_current.set_text("100%")
		self.main_window.show()
	

	"""
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	@ Interface methodes
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	"""
	
		
	def on_resize_toggled(self, widget):
		self.resize_video = widget.get_active()
		self.resize_width.set_sensitive(self.resize_video)
		self.resize_height.set_sensitive(self.resize_video)

	def on_framerate_toggled(self, widget):
		self.force_framerate = widget.get_active()
		self.framerate_fps.set_sensitive(self.force_framerate)
	def on_crop_label_toggled(self, widget):
		self.crop_label = widget.get_active()
		#self.bottom_crop.set_sensitive(self.crop_label)
		#self.top_crop.set_sensitive(self.crop_label)
	
	def get_force_framerate(self):
		return self.force_framerate
	
	def get_fps(self):
		return self.framerate_fps.get_value()
	
	def get_resize_video(self):
		return self.resize_video
	
	def get_resize_width(self):
		return int(self.resize_width.get_value())
	
	def get_resize_height(self):
		return int(self.resize_height.get_value())
		


	"""
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	@ on_help : run help doc
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	"""
	
	def on_help(self,data=None):
		#show Help contents
		try:
			if hasattr(gtk, "show_uri"):

				#helpfile = "ghelp:divx-converter"
				helpfile = "ghelp:" + "/usr/share/gnome/help/divx-converter/C/divx-converter.xml"
				screen = gtk.gdk.screen_get_default()
				gtk.show_uri(screen, helpfile, gtk.get_current_event_time())
			else:
				#import gnome
				#gnome.help_display("divx-converter")
				self.execute("yelp /usr/share/gnome/help/divx-converter/C/divx-converter.xml")
		except:
			self.execute("zenity --error --text=\"" + "Error : could not establish help system.!" + "\"")
		return
	
	
	"""
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	@ get_deinter : get deinterlacing info from the interface
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	"""
	def get_deinter(self, data=None):
		
		active = self.glade.get_widget("combobox4").get_active()
		
		if active == 0 :
			options = "pp=lb"
		if active == 1 :
			options = "pp=li"
		if active == 2 :
			options = "pp=ci"
		if active == 3 :
			options = "pp=md"
		if active == 4 :
			options = "pp=fd"
		if active == 5 :
			options = "pp=l5"
		if active == 6 :
			options = "yadif=0"
		if active == 7 :
			options = "yadif=2"

		
		return options


	"""
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	@ get_pp : get postprocessing subfilters
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	"""		
	def get_pp(self, data=None):
		
		active = self.glade.get_widget("combobox3").get_active()
		
		if active == 0 :
			options = "pp=de"
		if active == 1 :
			options = "pp=fa"
		if active == 2 :
			options = "pp=ac"
		if active == 3 :
			options = "pp=de/al:a"
		if active == 4 :
			options = "pp=default/tmpnoise:1:2:3"
	
		return options



	"""
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	@ get_denoze : get HQ 3D Denoiser
	++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	"""			
	def get_denoze(self, data=None):
		
		active = self.glade.get_widget("combobox5").get_active()
		
		if active == 0 :
			options = "hqdn3d=3:2:5"
		if active == 1 :
			options = "hqdn3d=4:3:6"
		if active == 2 :
			options = "hqdn3d=7:6:9"
		if active == 3 :
			options = "hqdn3d=10:9:12"
	
		return options		

	def get_vcodec(self, data=None):
		
		if self.glade.get_widget("divx").get_active():
			ext = 'mpeg4'
		if self.glade.get_widget("divx4").get_active():
			ext = 'mpeg4'
		if self.glade.get_widget("x264").get_active():
			ext = 'libx264'
		if self.glade.get_widget("xvid").get_active():
			ext = 'libxvid'
		
		return ext
		
	def on_acodec_togl(self, data=None):
		
		if self.glade.get_widget("mp3").get_active():
			
			self.glade.get_widget("hbox8").show()
			self.glade.get_widget("hbox6").show()
			self.glade.get_widget("hbox15").show()
			self.glade.get_widget("hbox9").show()
			self.glade.get_widget("hbox11").show()
			self.glade.get_widget("hbox14").show()
			
			
			self.glade.get_widget("hbox23").hide()
			self.glade.get_widget("hbox24").hide()
			
			self.glade.get_widget("vbox2").hide()
			
		
		if self.glade.get_widget("ac3").get_active():
			
			self.glade.get_widget("hbox8").hide()
			self.glade.get_widget("hbox6").hide()
			self.glade.get_widget("hbox15").hide()
			self.glade.get_widget("hbox9").hide()
			self.glade.get_widget("hbox11").hide()
			self.glade.get_widget("hbox14").hide()
						
			
			self.glade.get_widget("hbox23").show()
			self.glade.get_widget("hbox24").show()
			
			self.glade.get_widget("vbox2").hide()
			
			
		if self.glade.get_widget("acc").get_active():
			
			self.glade.get_widget("hbox8").hide()
			self.glade.get_widget("hbox6").hide()
			self.glade.get_widget("hbox15").hide()
			self.glade.get_widget("hbox9").hide()
			self.glade.get_widget("hbox11").hide()
			self.glade.get_widget("hbox14").hide()
						
			
			self.glade.get_widget("hbox23").hide()
			self.glade.get_widget("hbox24").hide()
			
			self.glade.get_widget("vbox2").show()
			
"""
==================
About Dialog Class
==================
"""
class AboutDialog(object):

    def __init__(self):
		ui_path = ("divx-converter/about.glade")
		PREFIX = os.path.normpath(os.path.join(os.path.dirname(__file__), ".."))
		
		self.glade = glade = gtk.glade.XML(os.path.join(PREFIX, ui_path))
		
		self.window = self.glade.get_widget("about_dialog")
		
		self.glade.signal_autoconnect(self)
		
		self.window.show()
    
    def on_close(self, widget, response):
        """
            Close was clicked, remove the window.
        """
        self.window.destroy()
