#!/usr/bin/env python
# -*- coding: utf-8 -*-
#       @FILE: options
#       
#       Copyright 2009 foxoman <romance990033@hotmail.com>
#			Blog : foxoman.wordpress.com
#			Development WEB : foxoman.googlecode.com
#       
#       This program is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#       
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#       
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.
#


import gtk
from subprocess import *
import re
from singleton import *
import commands
import main

class Options(InheritableSingleton):
	def __init__(self):	
		super(type(self), self).__init__()
		
		glade = main.Window().get_glade()
	
		self.glade = glade

	def get_audio_options(self):
		options = " -oac "
		
		if self.glade.get_widget("mp3").get_active():
			options += "mp3lame -lameopts "
			
			if self.glade.get_widget("abr").get_active():
				options += "abr:br=" + str(int(self.glade.get_widget("Audio SpinButton").get_value()))
				
			if self.glade.get_widget("cbr").get_active():
				model = self.glade.get_widget("cbr_vb").get_model()
				active = self.glade.get_widget("cbr_vb").get_active()
				preset = model[active][0];
				cbr = preset.strip()
				cbr = preset.replace("kbps","")
				options += "cbr:br=" + str(int(cbr))
				
	
			if self.glade.get_widget("vbr").get_active():
				model = self.glade.get_widget("vbr_vb").get_model()
				active = self.glade.get_widget("vbr_vb").get_active()
				preset = model[active][0];
				
				if preset == "Medium (VBR: 150-180 kbps)":
					vbr = "medium"
				if preset == "Standard (VBR: 170-210 kbps)":
					vbr ="standard"
				if preset == "Extreme (VBR: 200-240 kbps)":
					vbr = "extreme"
				if preset == "Insane (CBR: 320 kbps)":
					vbr = "insane"
				
				options += "preset=" + str(vbr)
			
			if self.glade.get_widget("checkbutton7").get_active():
				options += ":q=" + str(int(self.glade.get_widget("spinbutton5").get_value())) 
			
			
			if self.glade.get_widget("checkbutton5").get_active():
				options += ":aq=" + str(int(self.glade.get_widget("spinbutton6").get_value()))
				
			if self.glade.get_widget("checkbutton6").get_active():
				options += ":vol=" + str(int(self.glade.get_widget("spinbutton7").get_value()))
				
			if self.glade.get_widget("checkbutton4").get_active():
				active = self.glade.get_widget("combobox6").get_active()
				options += ":mode=" + str(int(active))
		
		if self.glade.get_widget("ac3").get_active():
			model = self.glade.get_widget("combobox8").get_model()
			active = self.glade.get_widget("combobox8").get_active()
			bit = model[active][0];
			
			options += ("lavc -lavcopts acodec=ac3:abitrate=%s -a52drc %s" % (str(int(bit)),str(int(self.glade.get_widget("spinbutton1").get_value()))))
		
		if self.glade.get_widget("acc").get_active():
			
			if self.glade.get_widget("checkbutton10").get_active():
				tem = ":tns"
			else:
				tem = ""
			options += ("faac -faacopts mpeg=4:object=2:quality=%s%s" % (str(int(self.glade.get_widget("spinbutton2").get_value())), tem))
		
		if self.glade.get_widget("srate_ch").get_active():
		
			model = self.glade.get_widget("srate").get_model()
			active = self.glade.get_widget("srate").get_active()
			srate = model[active][0];
			
			options += " -srate " + str(int(srate))
		
		return options
	
	def get_video_options(self, two_pass, first_pass_done, bitrate_size_combobox):
		options = "" # This string will hold the options for mencoder

		
		options += "-ffourcc" # This string will hold the options for mencoder
		
		model = self.glade.get_widget("combobox2").get_model()
		active = self.glade.get_widget("combobox2").get_active()
		preset = model[active][0];
		
		if self.glade.get_widget("divx").get_active():
			options += " DX50"
			
		if self.glade.get_widget("divx4").get_active():
			
			options += " DIVX"

				
		if self.glade.get_widget("x264").get_active():
			options += " h264"
				
		if self.glade.get_widget("xvid").get_active():
			options += " XVID"

		
		if main.Window().get_force_framerate():
			options += " -ofps " + str(int(main.Window().get_fps()))
		
		
		filters = " -vf "
		
		if self.glade.get_widget("deinter").get_active():
			filters += main.Window().get_deinter() + ","
		
		if self.glade.get_widget("crop_label").get_active() :
			crop = str(int(self.glade.get_widget("crop_1").get_value())) +":"+ str(int(self.glade.get_widget("crop_2").get_value())) +":"+ str(int(self.glade.get_widget("crop_3").get_value())) +":"+ str(int(self.glade.get_widget("crop_4").get_value()))
			filters += "crop=" + crop +","
			
		

		# pp
		if self.glade.get_widget("checkbutton8").get_active():
			filters += main.Window().get_pp() + ","
		
		# denosize	
		if self.glade.get_widget("checkbutton9").get_active():
			filters += main.Window().get_denoze() + ","


			
		if self.glade.get_widget("soft").get_active() :
			filters += "softskip,"
		
		if main.Window().get_resize_video():
			#Valid iPod resolution: up to 640x480
			if preset == "Apple iPod":
				size = "640:480"
			else:
				size = str(main.Window().get_resize_width()) + ":" + str(main.Window().get_resize_height())
			filters += "scale=" + size +","
			
		#filters += "spp=0:0:0,"			
			
		if self.glade.get_widget("hard").get_active() :
			filters += "harddup"
		
		
		
		options += filters
		
		
		if self.glade.get_widget("checkbutton1").get_active():
			as_model = self.glade.get_widget("combobox7").get_model()
			as_active = self.glade.get_widget("combobox7").get_active()
			aspect = as_model[as_active][0];
			
			options += " -aspect " + aspect
		
		vcodec = main.Window().get_vcodec()
		
		
		if self.glade.get_widget("ac3").get_active():
			acodec = "ac3"
		if self.glade.get_widget("mp3").get_active():
			acodec = "libmp3lame"
		if self.glade.get_widget("acc").get_active():
			acodec = "libfaac"
		options += (" -ovc lavc -lavcopts vcodec=%s:acodec=%s" % (vcodec,acodec))



		if two_pass:
			if first_pass_done:
				options += ":vpass=2"
			else:
				options += ":vpass=1:turbo"

		if self.glade.get_widget("checkbutton3").get_active(): # Bitrate
			if preset == "Apple iPod" :
				#Apple iPod video bitrate may not exceed 2500 kbps!
				options += ":vbitrate=2500"
			else:
				options += ":vbitrate=" + str(int(self.glade.get_widget("Video SpinButton").get_value()))
		
			
		options += ":threads=" + str(int(commands.getoutput("sed -n -e '/^processor/p' /proc/cpuinfo | wc -l")))
		
		if self.glade.get_widget("checkbutton11").get_active():
			
			options += ":subq="+ str(int(self.glade.get_widget("spinbutton3").get_value()))
		
		options += main.Window().get_preset_options()

		
		
		


		return options
