# http://en.wikipedia.org/wiki/Singleton_pattern#Python

class  InheritableSingleton (object):
    instances = {}
    def __new__(cls, *args, **kwargs): 
        if InheritableSingleton.instances.get(cls) is None:
            cls.__original_init__ = cls.__init__
            InheritableSingleton.instances[cls] = object.__new__(cls, *args, **kwargs)
        elif cls.__init__ == cls.__original_init__:
            def nothing(*args, **kwargs):
                pass
            cls.__init__ = nothing
        return InheritableSingleton.instances[cls]
